=encoding utf8

=head1 NAME

Mail::Message::Field::Unstructured - smart unstructured field

=head1 INHERITANCE

 Mail::Message::Field::Unstructured
   is a Mail::Message::Field::Full
   is a Mail::Message::Field
   is a Mail::Reporter

=head1 SYNOPSIS

  my $f = Mail::Message::Field::Unstructured->new('Comments', 'hi!');

=head1 DESCRIPTION

Unstructured fields do contain information which is not restricted in
any way.  RFC2822 defines some unstructured fields, but by default all
unknown fields are unstructured as well.  Things like attributes and
comments have no meaning for unstructured fields, but encoding does.

Extends L<"DESCRIPTION" in Mail::Message::Field::Full|Mail::Message::Field::Full/"DESCRIPTION">.

=head1 OVERLOADED

Extends L<"OVERLOADED" in Mail::Message::Field::Full|Mail::Message::Field::Full/"OVERLOADED">.

=over 4

=item overload: B<""> stringification

Inherited, see L<Mail::Message::Field::Full/"OVERLOADED">

=item overload: B<'""'> stringification

Inherited, see L<Mail::Message::Field/"OVERLOADED">

=item overload: B<'0+'> numification

Inherited, see L<Mail::Message::Field/"OVERLOADED">

=item overload: B<'<=>'> numeric comparison

Inherited, see L<Mail::Message::Field/"OVERLOADED">

=item overload: B<bool> boolean

Inherited, see L<Mail::Message::Field/"OVERLOADED">

=item overload: B<cmp> string comparison

Inherited, see L<Mail::Message::Field/"OVERLOADED">

=back

=head1 METHODS

Extends L<"METHODS" in Mail::Message::Field::Full|Mail::Message::Field::Full/"METHODS">.

=head2 Constructors

Extends L<"Constructors" in Mail::Message::Field::Full|Mail::Message::Field::Full/"Constructors">.

=over 4

=item $obj-E<gt>B<clone>()

Inherited, see L<Mail::Message::Field/"Constructors">

=item $class-E<gt>B<from>($field, %options)

Inherited, see L<Mail::Message::Field::Full/"Constructors">

=item $class-E<gt>B<new>($data)

When the C<$data> is specified as single line, the content part is considered to
be correcly (character) encoded and escaped.  Typically, it is a line as
read from file.  The folding of the line is kept as is.

In case more than one argument is provided, the second is considered the BODY.
Attributes and other special things are not defined for unstructured fields,
and therefore not valid options.  The BODY can be a single string, a single
OBJECT, or an array of OBJECTS.  The objects are stringified (into a comma
separated list).  Each BODY element is interpreted with the specified encoding.

When the BODY is empty, the construction of the object fails: C<undef> is
returned.
Improves base, see L<Mail::Message::Field::Full/"METHODS">

 -Option  --Defined in                --Default
  charset   Mail::Message::Field::Full  undef
  encoding  Mail::Message::Field::Full  'q'
  force     Mail::Message::Field::Full  false
  language  Mail::Message::Field::Full  undef

=over 2

=item charset => $charset

=item encoding => 'q'|'Q'|'b'|'B'

=item force => BOOLEAN

=item language => $language

=back

» example: 

  my $s = Mail::Message::Field::Unstructured->new('Comment', 'Hi!');

  # Use autodetect
  my $s = Mail::Message::Field::Full->new('Comment', 'Hi!');
  my $s = Mail::Message::Field::Full->new('Comment: Hi!');

=back

=head2 Attributes

Extends L<"Attributes" in Mail::Message::Field::Full|Mail::Message::Field::Full/"Attributes">.

=over 4

=item $obj-E<gt>B<Name>()

Inherited, see L<Mail::Message::Field/"Attributes">

=item $obj-E<gt>B<body>()

Inherited, see L<Mail::Message::Field/"Attributes">

=item $obj-E<gt>B<folded>()

Inherited, see L<Mail::Message::Field/"Attributes">

=item $obj-E<gt>B<foldedBody>( [$body] )

Inherited, see L<Mail::Message::Field/"Attributes">

=item $obj-E<gt>B<name>()

Inherited, see L<Mail::Message::Field/"Attributes">

=item $obj-E<gt>B<unfoldedBody>( [$body, [$wrap]] )

Inherited, see L<Mail::Message::Field/"Attributes">

=item $obj-E<gt>B<wellformedName>( [STRING] )

Inherited, see L<Mail::Message::Field/"Attributes">

=back

=head2 The field

Extends L<"The field" in Mail::Message::Field::Full|Mail::Message::Field::Full/"The field">.

=over 4

=item $any-E<gt>B<isStructured>( [$name] )

Inherited, see L<Mail::Message::Field/"The field">

=item $obj-E<gt>B<length>()

Inherited, see L<Mail::Message::Field/"The field">

=item $obj-E<gt>B<nrLines>()

Inherited, see L<Mail::Message::Field/"The field">

=item $obj-E<gt>B<print>( [$fh] )

Inherited, see L<Mail::Message::Field/"The field">

=item $obj-E<gt>B<size>()

Inherited, see L<Mail::Message::Field/"The field">

=item $obj-E<gt>B<string>( [$wrap] )

Inherited, see L<Mail::Message::Field/"The field">

=item $obj-E<gt>B<toDisclose>()

Inherited, see L<Mail::Message::Field/"The field">

=back

=head2 Access to the body

Extends L<"Access to the body" in Mail::Message::Field::Full|Mail::Message::Field::Full/"Access to the body">.

=over 4

=item $obj-E<gt>B<decodedBody>(%options)

Inherited, see L<Mail::Message::Field::Full/"Access to the body">

=back

=head2 Access to the content

Extends L<"Access to the content" in Mail::Message::Field::Full|Mail::Message::Field::Full/"Access to the content">.

=over 4

=item $obj-E<gt>B<addresses>()

Inherited, see L<Mail::Message::Field/"Access to the content">

=item $obj-E<gt>B<attribute>( $name, [$value] )

Inherited, see L<Mail::Message::Field/"Access to the content">

=item $obj-E<gt>B<attributes>()

Inherited, see L<Mail::Message::Field/"Access to the content">

=item $obj-E<gt>B<beautify>()

Inherited, see L<Mail::Message::Field::Full/"Access to the content">

=item $obj-E<gt>B<comment>( [STRING] )

Inherited, see L<Mail::Message::Field/"Access to the content">

=item $any-E<gt>B<createComment>(STRING, %options)

Inherited, see L<Mail::Message::Field::Full/"Access to the content">

=item $any-E<gt>B<createPhrase>(STRING, %options)

Inherited, see L<Mail::Message::Field::Full/"Access to the content">

=item $any-E<gt>B<dateToTimestamp>(STRING)

Inherited, see L<Mail::Message::Field/"Access to the content">

=item $any-E<gt>B<stripCFWS>( [STRING] )

Inherited, see L<Mail::Message::Field/"Access to the content">

=item $obj-E<gt>B<study>()

Inherited, see L<Mail::Message::Field/"Access to the content">

=item $any-E<gt>B<toDate>( [$time] )

Inherited, see L<Mail::Message::Field/"Access to the content">

=item $obj-E<gt>B<toInt>()

Inherited, see L<Mail::Message::Field/"Access to the content">

=back

=head2 Internals

Extends L<"Internals" in Mail::Message::Field::Full|Mail::Message::Field::Full/"Internals">.

=over 4

=item $any-E<gt>B<decode>(STRING, %options)

Inherited, see L<Mail::Message::Field::Full/"Internals">

=item $obj-E<gt>B<encode>(STRING, %options)

Inherited, see L<Mail::Message::Field::Full/"Internals">

=back

=head2 Parsing

Extends L<"Parsing" in Mail::Message::Field::Full|Mail::Message::Field::Full/"Parsing">.

=over 4

=item $obj-E<gt>B<consume>( $line | <$name,<$body|$objects>> )

Inherited, see L<Mail::Message::Field/"Parsing">

=item $any-E<gt>B<consumeComment>(STRING)

Inherited, see L<Mail::Message::Field::Full/"Parsing">

=item $obj-E<gt>B<consumeDotAtom>(STRING)

Inherited, see L<Mail::Message::Field::Full/"Parsing">

=item $any-E<gt>B<consumePhrase>(STRING)

Inherited, see L<Mail::Message::Field::Full/"Parsing">

=item $obj-E<gt>B<defaultWrapLength>( [$length] )

Inherited, see L<Mail::Message::Field/"Parsing">

=item $any-E<gt>B<fold>( $name, $body, [$maxchars] )

Inherited, see L<Mail::Message::Field/"Parsing">

=item $obj-E<gt>B<parse>(STRING)

Inherited, see L<Mail::Message::Field::Full/"Parsing">

=item $obj-E<gt>B<produceBody>()

Inherited, see L<Mail::Message::Field::Full/"Parsing">

=item $obj-E<gt>B<setWrapLength>( [$length] )

Inherited, see L<Mail::Message::Field/"Parsing">

=item $obj-E<gt>B<stringifyData>(STRING|ARRAY|$objects)

Inherited, see L<Mail::Message::Field/"Parsing">

=item $obj-E<gt>B<unfold>(STRING)

Inherited, see L<Mail::Message::Field/"Parsing">

=back

=head2 Error handling

Extends L<"Error handling" in Mail::Message::Field::Full|Mail::Message::Field::Full/"Error handling">.

=over 4

=item $obj-E<gt>B<AUTOLOAD>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<notImplemented>()

Inherited, see L<Mail::Reporter/"Error handling">

=back

=head2 Cleanup

Extends L<"Cleanup" in Mail::Message::Field::Full|Mail::Message::Field::Full/"Cleanup">.

=over 4

=item $obj-E<gt>B<DESTROY>()

Inherited, see L<Mail::Reporter/"Cleanup">

=back

=head1 DETAILS

Extends L<"DETAILS" in Mail::Message::Field::Full|Mail::Message::Field::Full/"DETAILS">.

=head1 DIAGNOSTICS

=over 4

=item Warning: attributes are not supported for unstructured fields.

Cast by C<new()>

=item Error: class $package does not implement method $method.

Fatal error: the specific C<$package> (or one of its superclasses) does not
implement this method where it should. This message means that some other
related classes do implement this method however the class at hand does
not.  Probably you should investigate this and probably inform the author
of the package.
Cast by C<notImplemented()>

=item Warning: field content is not numerical: $content

The numeric value of a field is requested (for instance the C<Lines> or
C<Content-Length> fields should be numerical), however the data contains
weird characters.
Cast by C<toInt()>

=item Error: field name too long (max $count), in '$name'.

It is not specified in the RFCs how long a field name can be, but
at least it should be a few characters shorter than the line wrap.
Cast by C<fold()>

=item Warning: illegal character in charset '$name'.

The field is created with an utf8 string which only contains data from the
specified character set.  However, that character set can never be a valid
name because it contains characters which are not permitted.
Cast by C<encode()>

=item Warning: illegal character in field name $name.

A new field is being created which does contain characters not permitted
by the RFCs.  Using this field in messages may break other e-mail clients
or transfer agents, and therefore mutulate or extinguish your message.
Cast by C<consume()>

=item Warning: illegal character in language '$name'.

The field is created with data which is specified to be in a certain language,
however, the name of the language cannot be valid: it contains characters
which are not permitted by the RFCs.
Cast by C<encode()>

=item Warning: illegal encoding '$name', using 'q'.

The RFCs only permit base64 (C<b > or C<B >) or quoted-printable
(C<q> or C<Q>) encoding.  Other than these four options are illegal.
Cast by C<encode()>

=item Warning: no extras for unstructured fields.

Cast by C<new()>

=back

=head1 SEE ALSO

This module is part of Mail-Message version 4.05,
built on April 10, 2026. Website: F<http://perl.overmeer.net/mailbox/>

=head1 LICENSE

For contributors see file ChangeLog.

This software is copyright (c) 2001-2026 by Mark Overmeer.

This is free software; you can redistribute it and/or modify it under
the same terms as the Perl 5 programming language system itself.

